- 题目链接:40. 组合总和 II - 力扣(LeetCode): https://leetcode.cn/problems/combination-sum-ii/
- 著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
给定一个候选人编号的集合 candidates
和一个目标数 target
,找出 candidates
中所有可以使数字和为 target
的组合。
candidates
中的每个数字在每个组合中只能使用 一次 。
注意:解集不能包含重复的组合。
1 <= candidates.length <= 100
1 <= candidates[i] <= 50
1 <= target <= 30
示例1
输入: candidates = [10,1,2,7,6,1,5], target = 8,
输出:
[[1,1,6],[1,2,5],[1,7],[2,6]]
示例2
输入: candidates = [2,5,2,1,2], target = 5,
输出:
[[1,2,2],[5]]
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
public class LeetCode40_01_01 {
public List<List<Integer>> ret = new ArrayList<>();
public List<Integer> tempList = new ArrayList<>();
public List<List<Integer>> combinationSum2(int[] candidates, int target) {
Arrays.sort(candidates);
backTracking(candidates, target, 0);
return ret;
}
public void backTracking(int[] candidates, int target, int startIndex) {
if (target == 0) {
ret.add(new ArrayList(tempList));
return;
} else if (target < 0) {
return;
}
for (int i = startIndex; i < candidates.length && candidates[i] <= target; i++) {
tempList.add(candidates[i]);
// 因为不能重复,所以下一轮就从 i + 1 开始
backTracking(candidates, target - candidates[i], i + 1);
tempList.remove(tempList.size() - 1);
// 因为此层已经使用过 candidates[i] 所以同层,和它相同的数字都跳过
while (i < candidates.length - 1 && candidates[i + 1] == candidates[i]) {
i++;
}
}
}
}
相比于 LeetCode 39 这题主要的麻烦在于重复
[1,2,5]
和[2,1,5]
是分别取前一个1
和后一个1
的结果,但这属于重复的解,需要舍弃[1,1,6]
两个1
虽然重复,但分别对应集合中不同的索引针对以上两个重复问题,我的思路主要是: